#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "php.h"
#include "php_int64.h"

static function_entry int64_functions[] = {
    PHP_FE(sdbmhash, NULL)
    {NULL, NULL, NULL}
};

zend_module_entry int64_module_entry = {
#if ZEND_MODULE_API_NO >= 20010901
    STANDARD_MODULE_HEADER,
#endif
    PHP_INT64_EXTNAME,
    int64_functions,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
#if ZEND_MODULE_API_NO >= 20010901
    PHP_INT64_VERSION,
#endif
    STANDARD_MODULE_PROPERTIES
};

#ifdef COMPILE_DL_INT64
ZEND_GET_MODULE(int64)
#endif

#include <sys/types.h>

PHP_FUNCTION(sdbmhash)
{
    char *str;
    int len;

    if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "s", &str, &len) == FAILURE)
    {
        RETURN_NULL();
    }

    u_int64_t hash = 0;
    while (*str){
        hash = (hash << 6) + (hash << 16) - hash + *str++;
    }
    char hash_str[100];
    snprintf(hash_str, 100, "%llu", hash);
    RETURN_STRING(hash_str, 1);
}
